SystemOrganization addCategory: #'Glamour-Morphic-Renderer'!
SystemOrganization addCategory: #'Glamour-Morphic-Renderer-Spotter'!

GLMRenderer subclass: #GLMMorphicRenderer
	instanceVariableNames: 'window'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicRenderer commentStamp: 'tg 4/1/2010 07:11' prior: 0!
This is the class responsible for the binding to Morphic.

| browser |
browser := GLMTabulator new.
browser column: #one; column: #two.

browser transmit to: #one; andShow: [:a | a list.].
browser transmit to: #two; from: #one; andShow: [ :a |
	a text.].
browser openOn: #(a b c d)!

!GLMMorphicRenderer methodsFor: 'opening' stamp: 'cyrilledelaunay 4/1/2011 16:25'!
open: aRenderable
	window := GLMMorphicWindowRenderer render: aRenderable from: self.
	^ window openInWorld! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 8/22/2010 23:31'!
renderAccordionCompositePresentation: aCompositePresentation
	^ GLMMorphicAccordionRenderer render: aCompositePresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering browsers' stamp: 'tg 8/24/2010 21:51'!
renderAccumulator: aBrowser 
	^ GLMMorphicAccumulatorRenderer render: aBrowser from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'TudorGirba 1/20/2011 21:53'!
renderActionListPresentation: anActionListPresentation 
	| container buttonModel button |
	container := GLMMorphic containerMorph.
	anActionListPresentation allActions withIndexDo: 
		[ :each :index | 
		buttonModel := GLMButtonModel new.
		buttonModel glamourPresentation: anActionListPresentation.
		buttonModel glamourAction: each.
		button := PluggableButtonMorph 
			on: buttonModel
			getState: nil
			action: #execute
			label: #buttonLabel.
		container 
			addMorph: button
			fullFrame: (LayoutFrame 
					fractions: (0 @ 0 corner: 1 @ 0)
					offsets: (0 @ ((index - 1) * 24) corner: 0 @ (index * 24))) ].
	^ container! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 9/3/2010 13:56'!
renderDiffPresentation: aPresentation
	^ GLMMorphicDiffRenderer render: aPresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'VeronicaUquillas 5/26/2010 13:44'!
renderDropDownListPresentation: aDropListPresentation
	| listModel |

	listModel:= GLMDropListModel new glamourPresentation: aDropListPresentation.
	"When the morph changes, we want to update the glamour model"
	listModel announcer on: GLMDropDownListMorphSelectionChanged do: [ :ann | 	
		aDropListPresentation selection: ann selectionValue ].
	
	^(MorphDropListMorph
			on: listModel
			list: #list
			selected: #selectionIndex
			changeSelected: #selectionIndex:
			useIndex: true )
		hResizing: #spaceFill;
		vResizing: #shrinkWrap! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'TudorGirba 2/4/2011 18:10'!
renderDynamicPresentation: aPresentation
	^ GLMMorphicDynamicRenderer render: aPresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering browsers' stamp: 'TudorGirba 1/2/2011 18:58'!
renderExpander: aBrowser 
	^ GLMMorphicExpanderRenderer render: aBrowser from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'TudorGirba 4/12/2011 10:33'!
renderEyeSeePresentation: aPresentation
	^ GLMMorphicEyeSeeRenderer render: aPresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering browsers' stamp: 'TudorGirba 2/15/2011 18:07'!
renderFinder: aBrowser 
	^ aBrowser hasFixedSizePanes 
		ifTrue: [GLMMorphicFixedPanesFinderRenderer render: aBrowser from: self]
		ifFalse: [GLMMorphicVariablePanesFinderRenderer render: aBrowser from: self]! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'TudorGirba 1/20/2011 21:53'!
renderInputPresentation: aPresentation 
	
	| morph |
	self flag: 'hook the cuis editor'.
	morph := GLMMorphic containerMorph.
	^ morph! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 10/28/2010 19:55'!
renderLabelPresentation: aLabelPresentation 
	| morph | 
	morph := (LabelMorph contents: aLabelPresentation formatedDisplayValue) 
			layoutFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1));
			vResizing: #spaceFill;
			hResizing: #spaceFill;
			font: StandardFonts haloFont;
			yourself.
	^morph! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 8/22/2010 23:14'!
renderListPresentation: aListPresentation 
	^ GLMMorphicListRenderer render: aListPresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 8/22/2010 23:12'!
renderListingPresentation: aPresentation 
	^ GLMMorphicListingRenderer render: aPresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'TudorGirba 1/13/2011 13:46'!
renderMagrittePresentation: aMagrittePresentation 
	^ GLMMorphicMagritteRenderer render: aMagrittePresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 8/23/2010 00:22'!
renderMondrianPresentation: aPresentation
	^ GLMMorphicMondrianRenderer render: aPresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'TudorGirba 1/31/2011 01:57'!
renderMorphPresentation: aMorphPresentation 
	^ aMorphPresentation displayValue vResizing: #spaceFill; hResizing: #spaceFill! !

!GLMMorphicRenderer methodsFor: 'rendering' stamp: 'tg 8/24/2010 21:51'!
renderPane: aPane 
	^ GLMMorphicPaneRenderer render: aPane from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 8/22/2010 23:31'!
renderStackedVerticallyCompositePresentation: aCompositePresentation
	^ GLMMorphicVerticallyStackedRenderer render: aCompositePresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering browsers' stamp: 'tg 8/24/2010 21:50'!
renderStacker: aBrowser 
	^ GLMMorphicStackerRenderer render: aBrowser from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 8/22/2010 23:33'!
renderTabbedCompositePresentation: aCompositePresentation
	^ GLMMorphicTabbedRenderer render: aCompositePresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 8/22/2010 23:15'!
renderTablePresentation: aPresentation 
	^ GLMMorphicTableRenderer render: aPresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering browsers' stamp: 'tg 8/24/2010 21:50'!
renderTabulator: aBrowser 
	^ GLMMorphicTabulatorRenderer render: aBrowser from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 8/22/2010 20:22'!
renderTextPresentation: aTextPresentation 
	^ GLMMorphicTextRenderer render: aTextPresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 8/22/2010 23:16'!
renderTreePresentation: aPresentation 
	^ GLMMorphicTreeRenderer render: aPresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering browsers' stamp: 'cyrilledelaunay 3/23/2011 13:24'!
renderValidator: aBrowser 
	^ GLMMorphicValidatorRenderer new render: aBrowser from: self! !

!GLMMorphicRenderer methodsFor: 'rendering browsers' stamp: 'cyrilledelaunay 4/1/2011 10:40'!
renderWizard: aGLMWizard

	|tmpRenderer|
	tmpRenderer :=  GLMMorphicWizardRenderer new.
	aGLMWizard  setSpecificAnnouncementActionsTo: tmpRenderer.  
	^ tmpRenderer render: aGLMWizard! !

!GLMMorphicRenderer methodsFor: 'accessing' stamp: 'tg 8/23/2010 00:33'!
window
	^ window! !

!GLMMorphicRenderer methodsFor: 'accessing' stamp: 'tg 8/23/2010 00:33'!
window: anObject
	window := anObject! !

Notification subclass: #GLMSingleSpotterRequest
	instanceVariableNames: 'prompt default assisted searchBlock labelBlock iconBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer-Spotter'!

!GLMSingleSpotterRequest classSide methodsFor: 'utilities' stamp: 'ML 2/26/2011 15:02'!
substring: testString matches: aString caseSensitive: aBoolean
	"Checks if a testString is a substring of aString. The matching parts do not necessarily need to be consecutive, for example 'egli' matches 'renggli'."

	| index |
	index := 0.
	testString do: [ :char |
		index := aString
			findString: (String with: char)
			startingAt: index + 1
			caseSensitive: aBoolean.
		index = 0
			ifTrue: [ ^ false ] ].
	^ true! !

!GLMSingleSpotterRequest methodsFor: 'accessing' stamp: 'ML 2/26/2011 15:02'!
assisted
	^ assisted! !

!GLMSingleSpotterRequest methodsFor: 'accessing' stamp: 'ML 2/26/2011 15:02'!
assisted: aBoolean
	"A boolean indicating that the typing of the user is assisted but not constrained."
	
	assisted := aBoolean! !

!GLMSingleSpotterRequest methodsFor: 'configuration' stamp: 'ML 2/26/2011 15:02'!
collection: aCollection
	self collection: aCollection caseSensitive: false! !

!GLMSingleSpotterRequest methodsFor: 'configuration' stamp: 'ML 2/26/2011 15:02'!
collection: aCollection caseSensitive: aBoolean
	"Configure this completion dialog with aCollection and match the elements case sensitive if aBoolean is true. Display the complete list if the filter is empty."

	self searchBlock: [ :value |
		value isEmpty
			ifTrue: [ aCollection ]
			ifFalse: [
				aCollection select: [ :each |
					self class
						substring: value
						matches: (self labelFor: each)
						caseSensitive: aBoolean ] ] ]! !

!GLMSingleSpotterRequest methodsFor: 'accessing' stamp: 'ML 2/26/2011 15:02'!
default
	^ default! !

!GLMSingleSpotterRequest methodsFor: 'accessing' stamp: 'ML 2/26/2011 15:02'!
default: aString
	"The default string initially used for filtering."
	
	default := aString! !

!GLMSingleSpotterRequest methodsFor: 'dispatching' stamp: 'ML 2/26/2011 15:02'!
handleWith: anObject
	^ anObject handleCompletionRequest: self! !

!GLMSingleSpotterRequest methodsFor: 'accessing' stamp: 'ML 2/26/2011 15:02'!
iconBlock
	^ iconBlock! !

!GLMSingleSpotterRequest methodsFor: 'accessing' stamp: 'ML 2/26/2011 15:02'!
iconBlock: aOneArgumentBlock
	"A one argument block answering the icon symbol for a given element."
	
	iconBlock := aOneArgumentBlock! !

!GLMSingleSpotterRequest methodsFor: 'querying' stamp: 'ML 2/26/2011 15:02'!
iconFor: anObject
	^ iconBlock value: anObject! !

!GLMSingleSpotterRequest methodsFor: 'initialization' stamp: 'ML 2/26/2011 15:02'!
initialize
	super initialize.
	prompt := 'Completion Request'.
	default := String new.
	assisted := false.
	searchBlock := [ :value | #() ].
	labelBlock := [ :value | value asString ].
	iconBlock := [ :value | nil ]! !

!GLMSingleSpotterRequest methodsFor: 'accessing' stamp: 'ML 2/26/2011 15:02'!
labelBlock
	^ labelBlock! !

!GLMSingleSpotterRequest methodsFor: 'accessing' stamp: 'ML 2/26/2011 15:02'!
labelBlock: aOneArgumentBlock
	"A one argument block answering the string for a given element."
	
	labelBlock := aOneArgumentBlock! !

!GLMSingleSpotterRequest methodsFor: 'querying' stamp: 'ML 2/26/2011 15:02'!
labelFor: anObject
	^ labelBlock value: anObject! !

!GLMSingleSpotterRequest methodsFor: 'accessing' stamp: 'ML 2/26/2011 16:56'!
name
	^self prompt! !

!GLMSingleSpotterRequest methodsFor: 'accessing' stamp: 'ML 2/26/2011 15:02'!
prompt
	^ prompt! !

!GLMSingleSpotterRequest methodsFor: 'accessing' stamp: 'ML 2/26/2011 15:02'!
prompt: aString
	"A string with the title for this request."
	
	prompt := aString! !

!GLMSingleSpotterRequest methodsFor: 'accessing' stamp: 'ML 2/26/2011 15:02'!
searchBlock
	^ searchBlock! !

!GLMSingleSpotterRequest methodsFor: 'accessing' stamp: 'ML 2/26/2011 15:02'!
searchBlock: aOneArgumentBlock
	"A one argument block returning the elements for the given filter."
	
	searchBlock := aOneArgumentBlock! !

!GLMSingleSpotterRequest methodsFor: 'querying' stamp: 'ML 2/26/2011 15:02'!
valuesFor: anObject
	^ searchBlock value: anObject! !

Notification subclass: #GLMSpotterRequest
	instanceVariableNames: 'requests prompt default'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer-Spotter'!

!GLMSpotterRequest methodsFor: 'initialize-release' stamp: 'ML 2/26/2011 16:07'!
add: aRequest
	requests add: aRequest ! !

!GLMSpotterRequest methodsFor: 'accessing' stamp: 'ML 2/26/2011 16:20'!
default
	^ default! !

!GLMSpotterRequest methodsFor: 'accessing' stamp: 'ML 2/26/2011 16:20'!
default: anObject
	default := anObject! !

!GLMSpotterRequest methodsFor: 'initialize-release' stamp: 'TudorGirba 2/27/2011 15:25'!
defaultAction
	^(GLMMorphicSpotter openOn: self) answer! !

!GLMSpotterRequest methodsFor: 'initialize-release' stamp: 'ML 2/26/2011 16:10'!
handleWith: anObject
	^ anObject handleCompletionRequest: self! !

!GLMSpotterRequest methodsFor: 'initialize-release' stamp: 'ML 2/26/2011 16:08'!
initialize
	super initialize.
	requests := OrderedCollection new.! !

!GLMSpotterRequest methodsFor: 'accessing' stamp: 'ML 2/26/2011 16:19'!
prompt
	^ prompt! !

!GLMSpotterRequest methodsFor: 'accessing' stamp: 'ML 2/26/2011 16:19'!
prompt: anObject
	prompt := anObject! !

!GLMSpotterRequest methodsFor: 'accessing' stamp: 'ML 2/26/2011 16:29'!
requests
	^requests ! !

GLMAction subclass: #GLMMorphicAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicAction methodsFor: 'testing' stamp: 'tg 9/24/2010 15:36'!
worksWithMorphic
	^ true! !

!GLMMorphicAction methodsFor: 'testing' stamp: 'tg 9/24/2010 15:36'!
worksWithSeaside
	^ false! !

DialogWindow subclass: #GLMMorphicSingleSpotter
	instanceVariableNames: 'textMorph text listMorph listValues listLabels listIndex answer parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer-Spotter'!

!GLMMorphicSingleSpotter classSide methodsFor: 'instance creation' stamp: 'ML 2/26/2011 17:05'!
on: aRequest
	^ self basicNew initializeOn: aRequest! !

!GLMMorphicSingleSpotter classSide methodsFor: 'instance creation' stamp: 'MirceaLungu 2/26/2011 17:59'!
on: aRequest parent: parent
	^ self basicNew initializeOn: aRequest parent: parent! !

!GLMMorphicSingleSpotter classSide methodsFor: 'instance creation' stamp: 'ML 2/26/2011 17:05'!
openOn: aRequest
	^ UITheme builder openModal: (self on: aRequest)! !

!GLMMorphicSingleSpotter methodsFor: 'accessing' stamp: 'ML 2/26/2011 17:05'!
answer
	"Answer the result of the dialog or nil, if this dialog has been cancelled."
	
	^ answer! !

!GLMMorphicSingleSpotter methodsFor: 'callbacks' stamp: 'ML 2/26/2011 17:05'!
arrowKey: anEvent from: aMorph
	"Ignore this request."! !

!GLMMorphicSingleSpotter methodsFor: 'actions' stamp: 'ML 2/26/2011 17:05'!
cancel
	answer := nil.
	^ super cancel! !

!GLMMorphicSingleSpotter methodsFor: 'callbacks' stamp: 'ML 2/26/2011 17:05'!
clickIconAt: anInteger
	"Ignore this request."! !

!GLMMorphicSingleSpotter methodsFor: 'morphic' stamp: 'ML 2/26/2011 17:05'!
defaultFocusMorph
	^ textMorph! !

!GLMMorphicSingleSpotter methodsFor: 'morphic' stamp: 'MirceaLungu 2/26/2011 18:10'!
deselect
	self listIndex: 0.  ! !

!GLMMorphicSingleSpotter methodsFor: 'callbacks' stamp: 'ML 2/26/2011 17:05'!
doubleClick
	self ok! !

!GLMMorphicSingleSpotter methodsFor: 'callbacks' stamp: 'ML 2/26/2011 17:05'!
editorKeyStroke: anEvent
	anEvent keyCharacter = Character arrowDown ifTrue: [
		self listIndex: (self listIndex + 1 min: listValues size).
		^ true ].
	anEvent keyCharacter = Character arrowUp ifTrue: [
		self listIndex: (self listIndex - 1 max: 1). 
		^ true ].
	^ false! !

!GLMMorphicSingleSpotter methodsFor: 'callbacks' stamp: 'ML 2/26/2011 17:05'!
iconAt: anIndex
	^ model iconFor: (listValues at: anIndex ifAbsent: [ ^ nil ])! !

!GLMMorphicSingleSpotter methodsFor: 'initialization' stamp: 'ML 2/26/2011 17:05'!
initializeOn: aRequest
	model := aRequest.
	listValues := listLabels := #().
	listIndex := 0.
	self initialize.
	self title: aRequest prompt.
	self text: aRequest default
! !

!GLMMorphicSingleSpotter methodsFor: 'initialization' stamp: 'MirceaLungu 2/26/2011 18:05'!
initializeOn: aRequest parent: theParent
	parent := theParent.
	self initializeOn: aRequest.
! !

!GLMMorphicSingleSpotter methodsFor: 'testing' stamp: 'ML 2/26/2011 17:05'!
isAssisted
	^ self model assisted! !

!GLMMorphicSingleSpotter methodsFor: 'testing' stamp: 'ML 2/26/2011 17:05'!
isEnabled
	^ self model assisted
		ifTrue: [ self text isEmptyOrNil not ]
		ifFalse: [ self listIndex > 0 ]! !

!GLMMorphicSingleSpotter methodsFor: 'accessing-list' stamp: 'ML 2/26/2011 17:05'!
listIndex
	^ listIndex! !

!GLMMorphicSingleSpotter methodsFor: 'accessing-list' stamp: 'MirceaLungu 2/26/2011 18:09'!
listIndex: anInteger
	anInteger isZero not ifTrue: [
		parent selectionIn: self.].
	listIndex = anInteger
		ifTrue: [ ^ self ].
	listIndex := anInteger.
	self listSelection ifNotNil: [ :selection |
		self isAssisted ifTrue: [ 
			text := self model labelFor: self listSelection.
			self changed: #text ] ].
	self changed: #listIndex; changed: #isEnabled! !

!GLMMorphicSingleSpotter methodsFor: 'accessing-list' stamp: 'ML 2/26/2011 17:05'!
listLabels
	^ listLabels! !

!GLMMorphicSingleSpotter methodsFor: 'accessing-list' stamp: 'ML 2/26/2011 17:05'!
listSelection
	^ listValues at: self listIndex ifAbsent: [ nil ]! !

!GLMMorphicSingleSpotter methodsFor: 'accessing-list' stamp: 'MirceaLungu 2/26/2011 18:04'!
listSelection: anObject

	self listIndex: (listValues indexOf: anObject ifAbsent: [ 0 ])! !

!GLMMorphicSingleSpotter methodsFor: 'accessing-list' stamp: 'ML 2/26/2011 17:05'!
listValues
	^ listValues! !

!GLMMorphicSingleSpotter methodsFor: 'accessing-list' stamp: 'ML 2/26/2011 17:05'!
listValues: aCollection
	| previous |
	previous := self listSelection.
	listValues := aCollection asArray.
	listLabels := listValues
		collect: [ :each | model labelFor: each ].
	self changed: #listLabels; listSelection: previous! !

!GLMMorphicSingleSpotter methodsFor: 'morphic' stamp: 'ML 2/26/2011 17:05'!
newContentMorph
	^ (self newColumn: { self newTextMorph. self newListMorph })
		minWidth: 320;
		minHeight: 200;
		yourself! !

!GLMMorphicSingleSpotter methodsFor: 'morphic' stamp: 'ML 2/26/2011 17:05'!
newListMorph
	listMorph := OBPluggableListMorph
		on: self
		list: #listLabels
		selected: #listIndex
		changeSelected: #listIndex:.
	listMorph
		borderStyle: (self theme listNormalBorderStyleFor: listMorph);
		color: (self theme listNormalFillStyleFor: listMorph);
		cornerStyle: self preferredCornerStyle;
		doubleClickSelector: #doubleClick;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		autoDeselect: false.
	^ listMorph! !

!GLMMorphicSingleSpotter methodsFor: 'morphic' stamp: 'ML 2/26/2011 17:05'!
newOKButton
	^ self newOKButtonFor: self getEnabled: #isEnabled! !

!GLMMorphicSingleSpotter methodsFor: 'morphic' stamp: 'ML 2/26/2011 17:05'!
newTextMorph
	textMorph := self
		newTextEntryFor: self
		getText: #text
		setText: #text:
		help: nil.
	textMorph
		autoAccept: true;
		selectAll.
	textMorph textMorph
		on: #keyStroke send: #editorKeyStroke: to: self.
	^ textMorph! !

!GLMMorphicSingleSpotter methodsFor: 'actions' stamp: 'ML 2/26/2011 17:05'!
ok
	answer := self model assisted
		ifTrue: [ self text ]
		ifFalse: [ self listSelection ].
	^ super ok! !

!GLMMorphicSingleSpotter methodsFor: 'accessing' stamp: 'MirceaLungu 2/26/2011 17:58'!
parent
	^ parent! !

!GLMMorphicSingleSpotter methodsFor: 'accessing' stamp: 'MirceaLungu 2/26/2011 17:58'!
parent: anObject
	parent := anObject! !

!GLMMorphicSingleSpotter methodsFor: 'accessing-text' stamp: 'ML 2/26/2011 17:05'!
text
	^ text! !

!GLMMorphicSingleSpotter methodsFor: 'accessing-text' stamp: 'ML 2/26/2011 17:05'!
text: aString
	text = aString
		ifTrue: [ ^ self ].
	text := aString.
	self listValues: (self model valuesFor: text).
	self isAssisted ifFalse: [
		self listIndex: (self listLabels size = 1
			ifTrue: [ 1 ]
			ifFalse: [ self listLabels findFirst: [ :each | each sameAs: text ] ]) ].
	self changed: #text; changed: #isEnabled! !

DialogWindow subclass: #GLMMorphicSpotter
	instanceVariableNames: 'textMorph text answer childrenMorphs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer-Spotter'!

!GLMMorphicSpotter classSide methodsFor: 'instance creation' stamp: 'ML 2/26/2011 17:15'!
on: aRequest
	^ self basicNew initializeOn: aRequest! !

!GLMMorphicSpotter classSide methodsFor: 'instance creation' stamp: 'ML 2/26/2011 17:15'!
openOn: aRequest
	^ UITheme builder openModal: (self on: aRequest)! !

!GLMMorphicSpotter methodsFor: 'accessing' stamp: 'ML 2/26/2011 17:08'!
answer
	^ answer! !

!GLMMorphicSpotter methodsFor: 'accessing' stamp: 'ML 2/26/2011 17:08'!
answer: anObject
	answer := anObject! !

!GLMMorphicSpotter methodsFor: 'accessing' stamp: 'ML 2/26/2011 17:08'!
childrenMorphs
	^ childrenMorphs! !

!GLMMorphicSpotter methodsFor: 'accessing' stamp: 'ML 2/26/2011 17:08'!
childrenMorphs: anObject
	childrenMorphs := anObject! !

!GLMMorphicSpotter methodsFor: 'callbacks' stamp: 'ML 2/26/2011 17:21'!
editorKeyStroke: anEvent
"	anEvent keyCharacter = Character arrowDown ifTrue: [
		self listIndex: (self listIndex + 1 min: listValues size).
		^ true ].
	anEvent keyCharacter = Character arrowUp ifTrue: [
		self listIndex: (self listIndex - 1 max: 1). 
		^ true ]."
	^ false! !

!GLMMorphicSpotter methodsFor: 'initialization' stamp: 'ML 2/26/2011 17:18'!
initialize 
	childrenMorphs := OrderedCollection new.
	super initialize! !

!GLMMorphicSpotter methodsFor: 'initialization' stamp: 'ML 2/26/2011 17:16'!
initializeOn: aRequest
	model := aRequest.
	self initialize.
	self title: aRequest prompt.
	self text: aRequest default
! !

!GLMMorphicSpotter methodsFor: 'morphic' stamp: 'ML 2/26/2011 17:21'!
newContentMorph
	^ (self newColumn: 
			((OrderedCollection with: self newTextMorph) addAll: self newListMorphs; yourself) )
		minWidth: 320;
		minHeight: 200;
		yourself! !

!GLMMorphicSpotter methodsFor: 'morphic' stamp: 'TudorGirba 2/27/2011 15:25'!
newListMorphs
	| list |
	self model requests do: [:each | 
		list := (GLMMorphicSingleSpotter on: each parent: self).
		self childrenMorphs add: list ].
	^ childrenMorphs collect: #newListMorph! !

!GLMMorphicSpotter methodsFor: 'morphic' stamp: 'ML 2/26/2011 17:13'!
newTextMorph
	textMorph := self
		newTextEntryFor: self
		getText: #text
		setText: #text:
		help: nil.
	textMorph
		autoAccept: true;
		selectAll.
	textMorph textMorph
		on: #keyStroke send: #editorKeyStroke: to: self.
	^ textMorph! !

!GLMMorphicSpotter methodsFor: 'accessing' stamp: 'MirceaLungu 2/26/2011 18:14'!
ok
	| nonEmpty |
	nonEmpty := (self childrenMorphs select: [:e| e listIndex isZero not]).
	nonEmpty size = 1 ifTrue: [
			answer := nonEmpty first listSelection 
		] .
	
	
	^ super ok! !

!GLMMorphicSpotter methodsFor: 'callbacks' stamp: 'MirceaLungu 2/26/2011 18:10'!
selectionIn: singleSpotlight

	(self childrenMorphs reject: [:e| e = singleSpotlight] ) do: [:e| 
			e deselect.
		]! !

!GLMMorphicSpotter methodsFor: 'accessing' stamp: 'ML 2/26/2011 17:08'!
text
	^ text! !

!GLMMorphicSpotter methodsFor: 'accessing' stamp: 'ML 2/26/2011 17:14'!
text: aString
	text = aString
		ifTrue: [ ^ self ].
	text := aString.
	self childrenMorphs do: [:each | each text: aString ].
	self changed: #text; changed: #isEnabled! !

!GLMMorphicSpotter methodsFor: 'accessing' stamp: 'ML 2/26/2011 17:07'!
textMorph
	^ textMorph! !

!GLMMorphicSpotter methodsFor: 'accessing' stamp: 'ML 2/26/2011 17:07'!
textMorph: anObject
	textMorph := anObject! !

!ScrollBar methodsFor: '*glamour-morphic-renderer' stamp: 'TudorGirba 1/16/2011 13:10'!
glmAnimateValue: aNumber duration: anInteger
"	aNumber = value ifTrue: [^ self ]."
	anInteger <= 0 
		ifTrue: [ self setValue: aNumber ]
		ifFalse: [
			| startTime start end |
			startTime := Time millisecondClockValue.
			start := value "roundTo: scrollDelta".
			[ | delta |
			[ (delta := Time millisecondClockValue - startTime) < anInteger ] whileTrue: [
				self setValue: (aNumber - start) * (delta / anInteger) + start.
				Processor yield ].
				self setValue: aNumber ]
					fork ]! !

TestCase subclass: #GLMMorphicSpotterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer-Spotter'!

!GLMMorphicSpotterTest methodsFor: 'as yet unclassified' stamp: 'TudorGirba 2/27/2011 15:26'!
testCreation
	| composite classRequest methodRequest thirdRequest |
	composite  := GLMSpotterRequest new.

	classRequest := GLMSingleSpotterRequest new 
			prompt: 'Find Class';
			searchBlock: [ :string | OBCmdFindClass new findClassIn: Smalltalk pattern: string ];
			labelBlock: [ :class | class name ];
			iconBlock: [ :class | class browserIcon ].

	methodRequest := GLMSingleSpotterRequest new 
			prompt: 'Object Selectors';
			searchBlock: [ :string | Object selectors select: [:e| string, '*' match: e asString] ];
			labelBlock: [ :e | e ].

	thirdRequest := GLMSingleSpotterRequest new 
			prompt: 'Other Selectors';
			searchBlock: [ :string | Class selectors select: [:e| string, '*' match: e asString] ];
			labelBlock: [ :e | e ].
			
	(composite 
		add: classRequest;
		add: methodRequest;
		add: thirdRequest;
				signal) inspect.! !

Object subclass: #GLMMorphicWidgetRenderer
	instanceVariableNames: 'renderer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicWidgetRenderer commentStamp: '<historical>' prior: 0!
This is a helper class that is supposed to be subclassed for each rendering logic of a specific morph. For example, there will be a TreeRenderer, a TextRenderer etc!

GLMMorphicWidgetRenderer subclass: #GLMMorphicBrowserRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

GLMMorphicBrowserRenderer subclass: #GLMMorphicAccumulatorRenderer
	instanceVariableNames: 'tabs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicAccumulatorRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 12:25'!
actOnPaneAdded: ann 
	tabs 
		addLazyPage: (GLMMorphicPaneWithoutTitleRenderer new render: ann pane) 
		label: (self titleOrIconOf: ann pane presentations in: tabs)
		toolbar: nil
		collapsable: true.
	tabs selectedPageIndex: tabs pages size! !

!GLMMorphicAccumulatorRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 10:50'!
actOnPaneSelected: anAnnouncement
	tabs selectedPageIndex: anAnnouncement position! !

!GLMMorphicAccumulatorRenderer methodsFor: 'rendering' stamp: 'TudorGirba 4/12/2011 12:49'!
render: aBrowser
	aBrowser panes isEmpty ifTrue: [ ^ GLMMorphic emptyMorph ].
	tabs := LazyTabGroupMorph new.
	tabs
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		cornerStyle: (self theme tabGroupCornerStyleIn: nil);
		font: self theme labelFont.
	tabs announcer on: LazyTabPageChanged do: [:ann |  
		aBrowser activeEntity: ((aBrowser panes at: ann pageIndex) port: #entity) value ].
	tabs announcer on: LazyTabPageRemoved do: [:ann |  
		aBrowser removePaneIndex: ann pageIndex ].
	aBrowser panes do: [ :each | 
		tabs 
			addLazyPage: [ GLMMorphicPaneWithoutTitleRenderer new render: each ]
			label: (self titleOrIconOf: each presentations in: tabs)
			toolbar: (self renderToolbarForPresentation: each presentations inMorph: tabs )
			collapsable: true ].
	aBrowser on: GLMPaneSelected send: #actOnPaneSelected: to: self.
	aBrowser on: GLMPaneAdded send: #actOnPaneAdded: to: self.
	aBrowser on: GLMBrowserClosed send: #actOnBrowserClosed: to: self.
	tabs selectedPageIndex: tabs pages size.
	^ tabs! !

!GLMMorphicBrowserRenderer methodsFor: 'callbacks' stamp: 'TudorGirba 4/12/2011 12:49'!
actOnBrowserClosed: ann
	self renderer window delete! !

GLMMorphicBrowserRenderer subclass: #GLMMorphicExpanderRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicExpanderRenderer methodsFor: 'rendering' stamp: 'TudorGirba 3/9/2011 11:12'!
render: aBrowser
	^ self renderWithTree: aBrowser   ! !

!GLMMorphicExpanderRenderer methodsFor: 'rendering' stamp: 'TudorGirba 3/9/2011 10:20'!
renderWithExpanders: aBrowser
	| morph scroll panel expander |
	panel := PanelMorph new.
	panel 
		fillStyle: Color transparent;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		changeTableLayout;
		layoutInset: 2;
		cellInset: 2.
	scroll := GeneralScrollPane new.
	scroll 
		changeScrollerTableLayout;
		scrollTarget: panel.
	aBrowser panes do: [:each |
		expander := ExpanderMorph titleText: (each presentations titleValue ifNil: ['noname']).
		morph := GLMMorphicPaneWithoutTitleRenderer new render: each.
		morph 
			borderStyle: (UITheme current buttonSelectedBorderStyleFor: morph).
		expander addMorphBack: morph.
		panel addMorph: expander	].
	^ scroll! !

!GLMMorphicExpanderRenderer methodsFor: 'rendering' stamp: 'TudorGirba 4/12/2011 12:49'!
renderWithTree: aBrowser
	| treeMorph treeModel |
	treeModel := GLMExpanderTreeMorphModel new glamourExpander: aBrowser.
	treeMorph := LazyMorphTreeMorph new.
	treeMorph
		makeLastColumnUnbounded;
		getMenuSelector: #menu:shifted:;
		keystrokeActionSelector: #keyStroke:from:;
		cornerStyle: treeMorph preferredCornerStyle;
		borderStyle: (BorderStyle inset width: 1);
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		layoutFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1));
		preferedPaneColor: Color white;	
		model: treeModel;
		nodeListSelector: #roots;
		columns: ( OrderedCollection with: (MorphTreeColumn new rowMorphGetSelector: #elementColumn)).
	treeMorph vShowScrollBar.
	aBrowser on: GLMBrowserClosed send: #actOnBrowserClosed: to: self.
	^ treeMorph buildContents! !

GLMMorphicBrowserRenderer subclass: #GLMMorphicFinderRenderer
	instanceVariableNames: 'container'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicFinderRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 18:10'!
actOnPaneAdded: ann
	self subclassResponsibility! !

!GLMMorphicFinderRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 18:11'!
actOnPaneRemoved: ann
	self subclassResponsibility! !

!GLMMorphicFinderRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 18:11'!
actOnPaneReplaced: ann
	self subclassResponsibility! !

!GLMMorphicFinderRenderer methodsFor: 'rendering' stamp: 'TudorGirba 4/12/2011 12:49'!
registerAnnouncementsFor: aBrowser
	aBrowser 
		on: GLMPaneRemoved send: #actOnPaneRemoved: to: self.
	aBrowser 
		on: GLMPaneAdded send: #actOnPaneAdded: to: self.
	aBrowser 
		on: GLMPaneReplaced send: #actOnPaneReplaced: to: self.
	aBrowser 
		on: GLMBrowserClosed send: #actOnBrowserClosed: to: self.! !

!GLMMorphicFinderRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 18:09'!
render: aBrowser
	^ self subclassResponsibility! !

GLMMorphicFinderRenderer subclass: #GLMMorphicFixedPanesFinderRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicFixedPanesFinderRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 18:10'!
actOnPaneAdded: ann
	container pushPane: (self renderObject: ann pane)! !

!GLMMorphicFixedPanesFinderRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 18:10'!
actOnPaneRemoved: ann
	container popPane! !

!GLMMorphicFixedPanesFinderRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 18:10'!
actOnPaneReplaced: ann
	container popAndReplacePane: (self renderObject: ann newPane)! !

!GLMMorphicFixedPanesFinderRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 18:11'!
render: aBrowser
	container := GLMPaneScroller new
		name: 'scroller';
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		yourself.
	container maxPanes: aBrowser fixedSizePanes.
	self registerAnnouncementsFor: aBrowser.  
	aBrowser panes
		do: [ :each | container pushPane: (self renderObject: each) ].
	^ container! !

GLMMorphicFinderRenderer subclass: #GLMMorphicVariablePanesFinderRenderer
	instanceVariableNames: 'scrollPane'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicVariablePanesFinderRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 18:12'!
actOnPaneAdded: ann
	self addMorphFromObject: ann pane toContainer: container.
	scrollPane hScrollbar glmAnimateValue: 1.0 duration: 2000! !

!GLMMorphicVariablePanesFinderRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 18:12'!
actOnPaneRemoved: ann
	container removeMorph: container submorphs last.
	container removeMorph: container submorphs last! !

!GLMMorphicVariablePanesFinderRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 18:13'!
actOnPaneReplaced: ann
	container removeMorph: container submorphs last.
	container removeMorph: container submorphs last.
	self addMorphFromObject: ann newPane toContainer: container.
	scrollPane hScrollbar glmAnimateValue: 1.0 duration: 200! !

!GLMMorphicVariablePanesFinderRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 18:11'!
addMorphFromObject: anObject toContainer: aContainerMorph
	| renderedMorph |
	renderedMorph := (self renderObject: anObject)
				vResizing: #spaceFill;
				hResizing: #rigid;
				minimumExtent: 200@10;
				extent: 200@10;
				yourself.
	aContainerMorph addMorphBack: renderedMorph.
	aContainerMorph addMorphBack: (EdgeGripMorph new
		width: ProportionalSplitterMorph splitterWidth;
		hResizing: #rigid; "not the default this time, vResizing is also #spaceFill by default"
		target: renderedMorph)! !

!GLMMorphicVariablePanesFinderRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 18:13'!
render: aBrowser
	container := GLMMorphic containerMorph.
	container 
		changeTableLayout;
		listDirection: #leftToRight;
		vResizing: #spaceFill;
		hResizing: #shrinkWrap.
	scrollPane := GeneralScrollPane new
		changeScrollerTableLayout;
		scrollTarget: container;
		yourself.
	self registerAnnouncementsFor: aBrowser.  
	aBrowser panes do: [ :each | self addMorphFromObject: each toContainer: container ].
	^ scrollPane! !

GLMMorphicBrowserRenderer subclass: #GLMMorphicStackerRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicStackerRenderer methodsFor: 'rendering' stamp: 'TudorGirba 4/12/2011 12:49'!
render: aBrowser
	| tabs |
	aBrowser panes isEmpty ifTrue: [ ^ GLMMorphic emptyMorph ].
	tabs := LazyTabGroupMorph new.
	tabs
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		cornerStyle: (self theme tabGroupCornerStyleIn: nil);
		font: self theme labelFont.
	aBrowser panes do: [ :each | 
		self flag: 'add toolbar'.
		tabs 
			addLazyPage: [ GLMMorphicPaneWithoutTitleRenderer new render: each ]
			label: (self titleOrIconOf: each presentations in: tabs)
			toolbar: (self renderToolbarForPresentation: each presentations inMorph: tabs) ].
	tabs selectedPageIndex: 1.
	aBrowser on: GLMBrowserClosed send: #actOnBrowserClosed: to: self.
	^ tabs! !

GLMMorphicBrowserRenderer subclass: #GLMMorphicTabulatorRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicTabulatorRenderer methodsFor: 'rendering' stamp: 'TudorGirba 4/12/2011 12:49'!
render: aBrowser
	| container |
	container := GLMMorphic containerMorph.
	aBrowser cell isRow 
		ifTrue: 
			[ self 
				renderCustomRow: aBrowser cell
				ofPane: aBrowser pane
				inUI: container
				inBrowser: aBrowser ]
		ifFalse: 
			[ self 
				renderCustomColumn: aBrowser cell
				ofPane: aBrowser pane
				inUI: container
				inBrowser: aBrowser ].
	aBrowser on: GLMBrowserClosed send: #actOnBrowserClosed: to: self.
	^ container! !

!GLMMorphicTabulatorRenderer methodsFor: 'private' stamp: 'TudorGirba 1/20/2011 21:53'!
renderCustomColumn: aCell ofPane: aPane inUI: aMorph inBrowser: aBrowser 
	| pane totalSpans currentSpanPosition currentOffset |
	totalSpans := aCell children inject: 0 into: [ :sum :each | sum + each span ].
	currentSpanPosition := 0.
	currentOffset := 0.
	aCell children keysAndValuesDo: [ :index :each | 
		each hasId 
			ifTrue: [ pane := self renderObject: (aBrowser paneNamed: each id) ]
			ifFalse: [ 
				self 
					renderCustomRow: each
					ofPane: aPane
					inUI: (pane := GLMMorphic containerMorph)
					inBrowser: aBrowser.
				pane addPaneSplitters ].
		pane layoutFrame: (LayoutFrame new
					topFraction: currentSpanPosition / totalSpans offset: currentOffset + 2;
					leftFraction: 0 offset: 0;
					bottomFraction: (currentSpanPosition + each span) / totalSpans offset: currentOffset + each size - 2;
					rightFraction: 1 offset: 0;
					yourself).
		aMorph addMorphBack: pane.
		currentSpanPosition := currentSpanPosition + each span.
		currentOffset := currentOffset + each size ].
	(aCell children last size > 0) ifTrue: [
		(aMorph submorphs atLast: 2) layoutFrame bottomOffset: (aMorph submorphs atLast: 2) layoutFrame bottomOffset - aCell children last size. 
		aMorph submorphs last layoutFrame topOffset: aMorph submorphs last layoutFrame topOffset - aCell children last size. 
		aMorph submorphs last layoutFrame bottomOffset: aMorph submorphs last layoutFrame bottomOffset - aCell children last size.].
	aMorph addPaneSplitters! !

!GLMMorphicTabulatorRenderer methodsFor: 'private' stamp: 'TudorGirba 1/20/2011 21:53'!
renderCustomRow: aCell ofPane: aPane inUI: aMorph inBrowser: aBrowser 
	| pane totalSpans currentSpanPosition currentOffset |
	totalSpans := aCell children inject: 0 into: [ :sum :each | sum + each span ].
	currentSpanPosition := 0.
	currentOffset := 0.
	aCell children keysAndValuesDo: [ :index :each | 
		each hasId 
			ifTrue: [ pane := self renderObject: (aBrowser paneNamed: each id) ]
			ifFalse: [ self 
					renderCustomColumn: each
					ofPane: aPane
					inUI: (pane := GLMMorphic containerMorph)
					inBrowser: aBrowser.
				pane addPaneSplitters ].
		pane layoutFrame: (LayoutFrame new
				topFraction: 0 offset: 0;
				leftFraction: currentSpanPosition / totalSpans offset: currentOffset + 2;
				bottomFraction: 1 offset: 0;
				rightFraction: (currentSpanPosition + each span) / totalSpans offset: currentOffset + each size - 2;
				yourself).
		aMorph addMorphBack: pane.
		currentSpanPosition := currentSpanPosition + each span.
		currentOffset := currentOffset + each size ].
	(aCell children last size > 0) ifTrue: [
		(aMorph submorphs atLast: 2) layoutFrame rightOffset: (aMorph submorphs atLast: 2) layoutFrame rightOffset - aCell children last size. 
		aMorph submorphs last layoutFrame leftOffset: aMorph submorphs last layoutFrame leftOffset - aCell children last size. 
		aMorph submorphs last layoutFrame rightOffset: aMorph submorphs last layoutFrame rightOffset - aCell children last size.].
	aMorph addPaneSplitters! !

GLMMorphicBrowserRenderer subclass: #GLMMorphicValidatorRenderer
	instanceVariableNames: 'container'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicValidatorRenderer methodsFor: 'rendering' stamp: 'TudorGirba 4/12/2011 12:50'!
render: aBrowser

	|tmpButtons|
	tmpButtons := OrderedCollection new.
	aBrowser panes isEmpty ifTrue: [ 
		"|tmpPane|
		tmpPane := (GLMPane in: aBrowser) 
				addPresentation: aBrowser presentations; 
				yourself.	
		(tmpPane port: #entity) value: aBrowser entity.	
		aBrowser panes add: tmpPane"
			].
	aBrowser buttonActions do: [:aGLMAction |
		|buttonModel|
		buttonModel := GLMButtonModel new.
		buttonModel glamourPresentation: aBrowser.
		buttonModel glamourAction: aGLMAction.
		tmpButtons add: (PluggableButtonMorph 
			on: buttonModel
			getState: nil
			action: #execute
			label: #buttonLabel)
		].
	aBrowser on: GLMBrowserClosed send: #actOnBrowserClosed: to: self.
	^ (GLMMorphicValidatorPaneRenderer new buttons: tmpButtons; render: aBrowser panes anyOne)
	! !

!GLMMorphicValidatorRenderer methodsFor: 'rendering' stamp: 'cyrilledelaunay 3/23/2011 13:25'!
render: aBrowser from: aGLMRenderer

	self renderer: aGLMRenderer.
	^ self render: aBrowser
	! !

GLMMorphicBrowserRenderer subclass: #GLMMorphicWizardRenderer
	instanceVariableNames: 'scrollPane container parentRenderer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicWizardRenderer methodsFor: 'rendering' stamp: 'cyrilledelaunay 4/4/2011 14:52'!
actOnPaneAdded: ann
	container removeMorph: container submorphs last.
	self addMorphFromObject: ann pane toContainer: container.! !

!GLMMorphicWizardRenderer methodsFor: 'rendering' stamp: 'cyrilledelaunay 4/4/2011 15:53'!
actOnPaneRemoved: ann! !

!GLMMorphicWizardRenderer methodsFor: 'rendering' stamp: 'cyrilledelaunay 3/31/2011 16:33'!
actOnPaneReplaced: ann

	container removeMorph: container submorphs last.
	self addMorphFromObject: ann newPane toContainer: container.
	"scrollPane hScrollbar glmAnimateValue: 1.0 duration: 200"! !

!GLMMorphicWizardRenderer methodsFor: 'rendering' stamp: 'cyrilledelaunay 3/31/2011 17:25'!
addMorphFromObject: anObject toContainer: aContainerMorph

	| renderedMorph |
	renderedMorph := (self renderObject: anObject).
				"vResizing: #spaceFill;
				hResizing: #rigid;
				minimumExtent: 200@10;
				extent: 200@10;
				yourself."
	aContainerMorph addMorphBack: renderedMorph.! !

!GLMMorphicWizardRenderer methodsFor: 'accessing' stamp: 'cyrilledelaunay 4/1/2011 14:16'!
parentRenderer

	^ parentRenderer! !

!GLMMorphicWizardRenderer methodsFor: 'accessing' stamp: 'cyrilledelaunay 4/1/2011 14:17'!
parentRenderer: aGLMMorphicRenderer

	parentRenderer := aGLMMorphicRenderer! !

!GLMMorphicWizardRenderer methodsFor: 'rendering' stamp: 'TudorGirba 4/12/2011 12:50'!
registerAnnouncementsFor: aBrowser
	aBrowser 
		on: GLMPaneRemoved send: #actOnPaneRemoved: to: self.
	aBrowser 
		on: GLMPaneAdded send: #actOnPaneAdded: to: self.
	aBrowser 
		on: GLMPaneReplaced send: #actOnPaneReplaced: to: self.
	aBrowser 
		on: GLMBrowserClosed send: #actOnBrowserClosed: to: self.! !

!GLMMorphicWizardRenderer methodsFor: 'rendering' stamp: 'cyrilledelaunay 4/4/2011 16:43'!
render: aBrowser
	container := GLMMorphic containerMorph.
	container
		changeTableLayout;
		listDirection: #leftToRight;
		vResizing: #spaceFill;
		hResizing: #spaceFill.
	scrollPane := GeneralScrollPane new
		changeScrollerTableLayout;
		scrollTarget: container;
		yourself.
	self registerAnnouncementsFor: aBrowser.  
	self addMorphFromObject: (aBrowser stepsAndPanes at: aBrowser currentStep) last toContainer: container .
	^ scrollPane! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicCompositeRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

GLMMorphicCompositeRenderer subclass: #GLMMorphicAccordionRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicAccordionRenderer methodsFor: 'rendering' stamp: 'TudorGirba 1/31/2011 02:12'!
render: aPresentation
	| presentations container expander |
	presentations := aPresentation matchingPresentations.
	presentations isEmpty ifTrue: [ ^ GLMMorphic emptyMorph ].
	presentations size = 1 ifTrue: [ ^ self renderWithToolbar: presentations first ].
	container := GLMMorphic containerMorph.
	container changeTableLayout.
	presentations do: [ :each | 
		expander := self theme 
			newExpanderIn: container 
			label: (self titleOrIconOf: each in: container)
			forAll: {(self renderWithToolbar: each)}.
		container addMorphBack: expander.
		(aPresentation pane lastActivePresentation notNil and: [
			each title = aPresentation pane lastActivePresentation title ]) ifTrue: [
				expander expanded: true]].
	(aPresentation pane lastActivePresentation isNil and: [container submorphs notEmpty]) ifTrue: [
		container submorphs first expanded: true].
	^ container! !

GLMMorphicCompositeRenderer subclass: #GLMMorphicTabbedRenderer
	instanceVariableNames: 'tabs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicTabbedRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 11:19'!
actOnPresentationUpdated: ann
	| index presentations |
	presentations := ann presentation matchingPresentations.
	tabs clear.	
	presentations do: [ :each | 
		tabs 
			addLazyPage: [ self renderObject: each ]
			label: (self titleOrIconOf: each in: tabs)
			toolbar: (self renderToolbarForPresentation: each inMorph: tabs ) ].
	index := 1.
	presentations withIndexDo: [ :each :i | 
		ann presentation pane lastActivePresentation notNil and: [ 
			each title = ann presentation pane lastActivePresentation title ifTrue: [ 
				index := i ] ] ].
	tabs selectedPageIndex: index.! !

!GLMMorphicTabbedRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 11:16'!
render: aPresentation

	| presentations index |
	presentations := aPresentation matchingPresentations.
	presentations isEmpty ifTrue: [ ^ GLMMorphic emptyMorph ].
	(presentations size = 1 and: [ presentations first hasTitleIcon not ])
		ifTrue: [ ^ self renderWithTitleOrNil: presentations first ].
	tabs := LazyTabGroupMorph new.
	tabs
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		cornerStyle: (self theme tabGroupCornerStyleIn: nil);
		font: self theme buttonFont.
	tabs announcer when: LazyTabPageChanged do: [:ann |
		aPresentation pane lastActivePresentation: (aPresentation matchingPresentations at: (ann pageIndex)) ].
	presentations do: [ :each | 
		tabs 
			addLazyPage: [ self renderObject: each ]
			label: (self titleOrIconOf: each in: tabs)
			toolbar: (self renderToolbarForPresentation: each inMorph: tabs ) ].
	index := 1.
	presentations withIndexDo: [ :each :i | 
		(aPresentation pane isLastActivePresentation: each) 
			ifTrue: [ index := i ] ].
	tabs selectedPageIndex: index.
	aPresentation on: GLMPresentationUpdated send: #actOnPresentationUpdated: to: self.
	^ tabs! !

GLMMorphicCompositeRenderer subclass: #GLMMorphicVerticallyStackedRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicVerticallyStackedRenderer methodsFor: 'rendering' stamp: 'TudorGirba 1/20/2011 21:55'!
render: aPresentation
	| presentations container |
	presentations := aPresentation matchingPresentations.
	presentations isEmpty ifTrue: [ ^ GLMMorphic emptyMorph ].	
	container := GLMMorphic containerMorph.
	container changeTableLayout.
	presentations do: [ :each | 
		container addMorphBack: (self renderWithTitle: each) ].
	^ container! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicDiffRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicDiffRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/4/2011 18:16'!
render: aPresentation
	| textMorph |
	textMorph := (DiffMorph from: aPresentation displayValue first to: aPresentation displayValue last)
"			onKeyStrokeSend: #keystroke:from: to: textModel;
"			layoutFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1));
			vResizing: #spaceFill;
			hResizing: #spaceFill;
			color: Color white;
			yourself.
"	self installActionsOnUI: textModel fromPresentation: aTextPresentation.
	aTextPresentation selectedTextBlock: [ textMorph textMorph editor selection ].
	aTextPresentation textBlock: [ textMorph textMorph editor text ].
"	^textMorph! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicDynamicRenderer
	instanceVariableNames: 'container'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicDynamicRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 10:54'!
actOnPresentationUpdated: anAnnouncement
	container removeAllMorphs.
	container 
		addMorph: (self renderObject: anAnnouncement presentation currentPresentation) 
		fullFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1)) ! !

!GLMMorphicDynamicRenderer methodsFor: 'rendering' stamp: 'TudorGirba 4/11/2011 21:27'!
render: aPresentation
	container := GLMMorphic containerMorph.
	container 
		addMorph: (self renderObject: aPresentation currentPresentation) 
		fullFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1)).
	aPresentation on: GLMPresentationUpdated send: #actOnPresentationUpdated: to: self.
	^ container! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicEyeSeeRenderer
	instanceVariableNames: 'canvasScrollPane eyeseeCanvas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicEyeSeeRenderer methodsFor: 'private' stamp: 'TudorGirba 4/12/2011 11:28'!
actOnContextChanged: ann
	"ann property = #selection ifTrue: [ 
		eyeseeCanvas selected: (eyeseeCanvas root deepFindNodeWithEntity: ann value) ]"! !

!GLMMorphicEyeSeeRenderer methodsFor: 'private' stamp: 'TudorGirba 4/12/2011 11:08'!
actOnPresentationUpdate: ann
	ann presentation diagram: ESDiagramRenderer new.
	canvasScrollPane scroller removeMorph: canvasScrollPane scroller submorphs first.
	self eyeseeCanvasFor: ann presentation! !

!GLMMorphicEyeSeeRenderer methodsFor: 'private' stamp: 'TudorGirba 4/12/2011 10:33'!
eyeseeCanvasFor: aPresentation
	| eyeseeRenderer |
	eyeseeRenderer := aPresentation eyeseeRenderer.
	aPresentation renderOn: eyeseeRenderer.
	eyeseeCanvas := aPresentation canvas.
	eyeseeCanvas announcer 
			when: MOElementSelection
			do: [ :ann | aPresentation selection: ann element model ].
	eyeseeCanvas announcer
			when: MOMouseEnter
			do: [ :ann | aPresentation status: ann element model ].
	eyeseeCanvas announcer
			when: MOMouseLeave
			do: [ :ann | aPresentation status: nil ].
	canvasScrollPane scroller addMorph: eyeseeCanvas! !

!GLMMorphicEyeSeeRenderer methodsFor: 'rendering' stamp: 'TudorGirba 4/12/2011 10:25'!
render: aPresentation
	canvasScrollPane := ScrollPane new.
	self eyeseeCanvasFor: aPresentation.
	canvasScrollPane
		color: Color white;
		vResizing: #spaceFill;
		hResizing: #spaceFill.
	aPresentation on: GLMPresentationUpdated send: #actOnPresentationUpdate: to: self.
	aPresentation on: GLMContextChanged send: #actOnContextChanged: to: self.
	^ canvasScrollPane! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicListingRenderer
	instanceVariableNames: 'treeMorph treeModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

GLMMorphicListingRenderer subclass: #GLMMorphicListRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicListingRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 10:47'!
actOnContextChanged: anAnnouncement 
	anAnnouncement property = #selection ifTrue: [ 
		treeModel announcer suspendAllWhile: [
			treeMorph model explicitSelection: anAnnouncement value ] ] ! !

!GLMMorphicListingRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 10:46'!
actOnUpdatedPresentation: anAnnouncement
	treeMorph model updateRoots! !

!GLMMorphicListingRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 10:47'!
render: aPresentation
	| container textInput |
	treeModel := GLMTreeMorphModel new glamourPresentation: aPresentation.
	container := GLMMorphic containerMorph.
	treeMorph := self treeMorphFor: treeModel and: aPresentation.
	aPresentation allowsInput ifTrue: [
		textInput := self textInputFor: treeModel withHelpMessage: aPresentation helpMessage.
		treeMorph layoutFrame bottomOffset: -24.
		container addMorphBack: textInput ].
	container addMorphBack: treeMorph.
	self installActionsOnUI: treeModel fromPresentation: aPresentation.

	"When the morph changes, we want to update the glamour model"
	treeModel announcer on: GLMTreeMorphSelectionChanged do: [ :ann | 
		aPresentation announcer suspendAllWhile: [
			aPresentation selection: ann selectionValue.
			aPresentation selectionPath: ann selectionPathValue] ].
	treeModel announcer on: GLMTreeMorphStrongSelectionChanged do: [ :ann | 
		aPresentation strongSelection: ann strongSelectionValue ].
	
	"When the glamour model changes, we want to update the morph"
	aPresentation on: GLMContextChanged send: #actOnContextChanged: to: self.
	aPresentation on: GLMPresentationUpdated send: #actOnUpdatedPresentation: to: self.

	^ container! !

!GLMMorphicListingRenderer methodsFor: 'private' stamp: 'cyrille.delaunay 11/5/2010 13:03'!
textInputFor: treeModel withHelpMessage: helpStringMessage
	| textInput |
	textInput := self theme 
			newTextEntryIn: nil
			for: treeModel
			get: #inputText
			set: #inputText:
			class: String
			getEnabled: #inputTextEnabled
			help: helpStringMessage.
	textInput layoutFrame: (LayoutFrame 
				fractions: (0 @ 1 corner: 1 @ 1)
				offsets: (0 @ -24 corner: 0 @ 0)).
	^ textInput! !

!GLMMorphicListingRenderer methodsFor: 'private' stamp: 'jannik.laval 10/23/2010 18:19'!
treeMorphFor: treeModel and: aPresentation
	| treeMorph columns |
	treeMorph := LazyMorphTreeMorph new.
	treeMorph
		makeLastColumnUnbounded;
		doubleClickSelector: #onDoubleClick;
		getMenuSelector: #menu:shifted:;
		keystrokeActionSelector: #keyStroke:from:;
		cornerStyle: treeMorph preferredCornerStyle;
		borderStyle: (BorderStyle inset width: 1);
		autoDeselection: aPresentation allowsDeselection;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		layoutFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1)).
	columns := aPresentation columns isEmpty 
		ifTrue: [ OrderedCollection with: (MorphTreeColumn new rowMorphGetSelector: #elementColumn)]
		ifFalse: [
			aPresentation columns collect: [:each | 
				GLMMorphTreeColumn new 
					glamourColumn: each; 
					headerButtonLabel: (aPresentation titleValueOfColumn: each) 
					font: StandardFonts menuFont 
					target: nil 
					actionSelector: nil 
					arguments: #(); 
					yourself ].
		].
	treeMorph
		preferedPaneColor: Color white;	
		model: treeModel;
		nodeListSelector: #roots;
		columns: columns.
	aPresentation isMultiple 
		ifTrue: [treeMorph beMultiple] 
		ifFalse: [treeMorph beSingle].
	treeModel chunkSize: aPresentation amountToShow.
	treeMorph vShowScrollBar.
	^ treeMorph buildContents! !

GLMMorphicListingRenderer subclass: #GLMMorphicTableRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

GLMMorphicListingRenderer subclass: #GLMMorphicTreeRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicTreeRenderer methodsFor: 'rendering' stamp: 'tg 8/22/2010 23:18'!
render: aPresentation
	| container |
	container := super render: aPresentation.
	aPresentation shouldAllExpand ifTrue: [container submorphs first expandAll ].
	aPresentation shouldRootsExpand ifTrue: [container submorphs first expandRoots ].
	^ container! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicMagritteRenderer
	instanceVariableNames: 'scrollPane containerMorphClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicMagritteRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 12:36'!
actOnPresentationUpdated: ann
	scrollPane removeMorph: scrollPane submorphs last.
	scrollPane scrollTarget: (self magritteMorphFrom: ann presentation) ! !

!GLMMorphicMagritteRenderer methodsFor: 'rendering' stamp: 'cyrilledelaunay 4/8/2011 14:42'!
magritteMorphFrom: aMagrittePresentation
	| toShow description magritteMorph |
	toShow := aMagrittePresentation displayValue.
	description := (aMagrittePresentation magritteDescription glamourValue: toShow) copy.
	"Using MAContainerMorph can raise some problems, as it try to delete morphs after commiting. We don't want this behavior."
	(description morphClass = MAContainerMorph)
		ifTrue: [description morphClass: MASilentContainerMorph]. 
	magritteMorph := (description asMorphOn: toShow)
		addButtons;
		morph.
	magritteMorph
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		layoutChanged.
	^ magritteMorph! !

!GLMMorphicMagritteRenderer methodsFor: 'rendering' stamp: 'cyrilledelaunay 3/21/2011 11:30'!
render: aMagrittePresentation		.
	scrollPane := GeneralScrollPane new.
	scrollPane changeScrollerTableLayout.
	scrollPane scrollTarget: (self magritteMorphFrom: aMagrittePresentation).
	scrollPane layoutFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1) offsets: (0 @ 25 corner: 0 @ 0)).

	aMagrittePresentation on: GLMPresentationUpdated send: #actOnPresentationUpdated: to: self.
	^ scrollPane! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicMondrianRenderer
	instanceVariableNames: 'canvasScrollPane mondrianCanvas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicMondrianRenderer methodsFor: 'private' stamp: 'TudorGirba 2/15/2011 12:47'!
actOnContextChanged: ann
	ann property = #selection ifTrue: [ 
		mondrianCanvas selected: (mondrianCanvas root deepFindNodeWithEntity: ann value) ]! !

!GLMMorphicMondrianRenderer methodsFor: 'private' stamp: 'TudorGirba 2/15/2011 17:48'!
actOnPresentationUpdate: ann
	ann presentation view: MOViewRenderer new.
	canvasScrollPane scroller removeMorph: canvasScrollPane scroller submorphs first.
	self mondrianCanvasFor: ann presentation! !

!GLMMorphicMondrianRenderer methodsFor: 'private' stamp: 'TudorGirba 2/15/2011 17:50'!
mondrianCanvasFor: aPresentation
	| view |
	view := aPresentation view.
	view root interaction menu: [ :x | self menuIn: MenuMorph new for: aPresentation ].
	aPresentation renderOn: view.
	mondrianCanvas := aPresentation canvas.
	mondrianCanvas announcer
			when: MOElementSelection
			do: [ :ann | aPresentation selection: ann element model ].
	mondrianCanvas announcer
			when: MOMouseEnter
			do: [ :ann | aPresentation status: ann element model ].
	mondrianCanvas announcer
			when: MOMouseLeave
			do: [ :ann | aPresentation status: nil ].
	canvasScrollPane scroller addMorph: mondrianCanvas! !

!GLMMorphicMondrianRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 17:51'!
render: aPresentation
	canvasScrollPane := ScrollPane new.
	self mondrianCanvasFor: aPresentation.
	canvasScrollPane
		color: Color white;
		vResizing: #spaceFill;
		hResizing: #spaceFill.
	aPresentation on: GLMPresentationUpdated send: #actOnPresentationUpdate: to: self.
	aPresentation on: GLMContextChanged send: #actOnContextChanged: to: self.
	^ canvasScrollPane! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicPaneRenderer
	instanceVariableNames: 'container'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicPaneRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 11:07'!
actOnMatchingPresentationChanged: anAnnouncement 
	container removeAllMorphs.
	self renderContainerFor: anAnnouncement pane.
	self renderer window fullBounds! !

!GLMMorphicPaneRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 11:06'!
render: aPane
	container := GLMMorphic containerMorph.
	self renderContainerFor: aPane.
	aPane on: GLMMatchingPresentationsChanged send: #actOnMatchingPresentationChanged: to: self.
	^ container! !

!GLMMorphicPaneRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 11:06'!
renderContainerFor: aPane
	container
		addMorph: (self renderWithTitleOrNil: aPane presentations) fullFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1));
		adoptPaneColor: container paneColor! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicPaneWithoutTitleRenderer
	instanceVariableNames: 'container paneMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicPaneWithoutTitleRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 12:31'!
actOnMatchingPresentationsChanged: anAnnouncement 
	paneMorph	removeAllMorphs.
	self renderMorphFor: anAnnouncement pane.
	self renderer window fullBounds! !

!GLMMorphicPaneWithoutTitleRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 12:29'!
render: aPane
	paneMorph := GLMMorphic containerMorph.
	aPane
		on: GLMMatchingPresentationsChanged
		send: #actOnMatchingPresentationsChanged:
		to: self.
	self renderMorphFor: aPane.
	^ paneMorph! !

!GLMMorphicPaneWithoutTitleRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 12:29'!
renderMorphFor: aPane
	paneMorph
		addMorph: (self renderObject: aPane presentations) fullFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1));
		adoptPaneColor: paneMorph paneColor! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicTextRenderer
	instanceVariableNames: 'textModel textMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicTextRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 11:21'!
actOnContextChanged: ann 
	ann property = #selectionInterval
		ifTrue: [ textMorph setSelection: ann value ]! !

!GLMMorphicTextRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 11:20'!
actOnPresentationUpdated: ann 
	textModel text: ann presentation formatedDisplayValue.
	textModel changed: #text! !

!GLMMorphicTextRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 11:21'!
render: aPresentation
	| toShow |
	toShow := aPresentation formatedDisplayValue.
	textModel := (GLMTextModel new)
						text: toShow;
						glamourPresentation: aPresentation;
						highlightSmalltalk: aPresentation highlightSmalltalk;
						highlightSmalltalkContext: aPresentation highlightSmalltalkContext.
	textMorph := aPresentation highlightSmalltalk 
			ifTrue: [self smalltalkTextMorphForModel: textModel]
			ifFalse: [self textMorphForModel: textModel].
	
	"this is a horrible hack: 
	because we cannot get the update of when the text changes from the morph,
	we get the reference to the mutable text object :) :)"
	textModel text: textMorph textMorph asText.
	self installActionsOnUI: textModel fromPresentation: aPresentation.
	aPresentation selectedTextBlock: [ textMorph textMorph editor selection ].
	aPresentation textBlock: [ textMorph textMorph editor text ].
	aPresentation on: GLMPresentationUpdated send: #actOnPresentationUpdated: to: self.
	aPresentation on: GLMContextChanged send: #actOnContextChanged: to: self.
	^ textMorph! !

!GLMMorphicTextRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/18/2011 10:27'!
smalltalkTextMorphForModel: aTextModel
	| morph styler |
	morph := GLMPluggableShoutMorph new.
	styler := SHTextStylerST80 new
			view: morph;
			yourself.
	morph
		styler: styler;
		on: aTextModel
			text: #text
			accept: #accept:notifying:
			readSelection: #selection
			menu: #menu:shifted:;
		onKeyStrokeSend: #keystroke:from: to: aTextModel;
		layoutFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1));
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		color: Color white;
		yourself.
	^ morph! !

!GLMMorphicTextRenderer methodsFor: 'rendering' stamp: 'TudorGirba 12/1/2010 01:55'!
textMorphForModel: textModel
	^ (PluggableTextMorph
		on: textModel
		text: #text
		accept: #accept:notifying:
		readSelection: #selection
		menu: #menu:shifted:)
		onKeyStrokeSend: #keystroke:from: to: textModel;
		layoutFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1));
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		color: Color white;
		yourself! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicValidatorPaneRenderer
	instanceVariableNames: 'container paneMorph buttons'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicValidatorPaneRenderer methodsFor: 'rendering' stamp: 'cyrilledelaunay 3/23/2011 14:06'!
actOnMatchingPresentationsChanged: anAnnouncement 
	paneMorph	removeAllMorphs.
	self renderMorphFor: anAnnouncement pane.
	self renderer window fullBounds! !

!GLMMorphicValidatorPaneRenderer methodsFor: 'rendering' stamp: 'cyrilledelaunay 3/23/2011 14:07'!
buttonRowFrom: aCollectionOfButtons
	"Answer a new ok/cancel button row."

	|answer buttons e|
	buttons := aCollectionOfButtons.
	e := 0@0.
	buttons do: [:b | e := e max: b minExtent].
	buttons do: [:b | b extent: e].
	answer := Morph new
		color: Color transparent;
		changeTableLayout;
		cellInset: 8;
		listDirection: #leftToRight;
		listCentering: #bottomRight;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap.
	buttons do: [:b | answer addMorphBack: b].
	^answer

	! !

!GLMMorphicValidatorPaneRenderer methodsFor: 'accessing' stamp: 'cyrilledelaunay 3/23/2011 14:11'!
buttons

	^ buttons! !

!GLMMorphicValidatorPaneRenderer methodsFor: 'accessing' stamp: 'cyrilledelaunay 3/23/2011 14:12'!
buttons: aCollectionOfButtons

	buttons := aCollectionOfButtons! !

!GLMMorphicValidatorPaneRenderer methodsFor: 'rendering' stamp: 'cyrilledelaunay 3/23/2011 16:39'!
newColumnWith: aCollectionOfMorphElements
	"use this method to create a new column in your block"
	<lint: 'Utility methods' rationale: 'defined here to facilate the use of the library' author: 'cyrille.delaunay'>
	
	|answer|
	answer := PanelMorph new
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		fillStyle: Color transparent; "non pane color tracking"
		changeTableLayout;
		cellInset: 8; yourself.
	aCollectionOfMorphElements do: [:m | answer addMorphBack: m].
	^answer! !

!GLMMorphicValidatorPaneRenderer methodsFor: 'rendering' stamp: 'cyrilledelaunay 3/23/2011 14:14'!
render: aPane

	paneMorph := GLMMorphic containerMorph.
	aPane
		on: GLMMatchingPresentationsChanged
		send: #actOnMatchingPresentationsChanged:
		to: self.
	self renderMorphFor: aPane.
	^ paneMorph! !

!GLMMorphicValidatorPaneRenderer methodsFor: 'rendering' stamp: 'cyrilledelaunay 3/31/2011 17:13'!
renderCompositiePresentation: aCompositePresentation
	
	paneMorph := GLMMorphic containerMorph.
	paneMorph
		addMorph: 
			(self newColumnWith:  { (self renderObject: aCompositePresentation).  (self buttonRowFrom: self buttons) }) 
			fullFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1));
		"addMorphBack: (self buttonRowFrom: self buttons)  ;  "
		adoptPaneColor: paneMorph paneColor.
	
	^ paneMorph! !

!GLMMorphicValidatorPaneRenderer methodsFor: 'rendering' stamp: 'cyrilledelaunay 4/8/2011 12:07'!
renderMorphFor: aPane

	paneMorph
		addMorph: 
			("self newColumnWith:  {" (self renderObject: aPane presentations)".  (self buttonRowFrom: self buttons) }") 
			fullFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 0.90));
		addMorph:  (self buttonRowFrom: self buttons)
			fullFrame: (LayoutFrame fractions: (0 @ 0.93 corner: 1 @ 1));
		adoptPaneColor: paneMorph paneColor! !

!GLMMorphicWidgetRenderer classSide methodsFor: 'instance creation' stamp: 'tg 8/22/2010 20:20'!
render: aPresentation from: aRenderer
	^ self new 
		renderer: aRenderer;
		render: aPresentation! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'tg 8/22/2010 23:52'!
installActionsOnUI: aMorphicModel fromPresentation: aPresentation	 
	aMorphicModel when: GLMMenuItemSelected do: [ :ann | ann action actOn: aPresentation ].
	aMorphicModel when: GLMKeyStroke do: [ :ann | ann action actOn: aPresentation ].! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'tg 11/20/2010 22:21'!
menuIn: aMenuMorph for: aPresentation
	| subMenus targetMenuMorph subMenu |
	subMenus := Dictionary new.
	(aPresentation allActions select: [:each | each hasTitle and: [each hasIcon not]]) do: [ :action |
		targetMenuMorph := action category notNil 
			ifTrue: [ subMenus at: action category ifAbsentPut: [ 
					subMenu :=  MenuMorph new.
					aMenuMorph add: action category subMenu: subMenu.
					subMenu ] ]
			ifFalse: [ aMenuMorph ].
		targetMenuMorph 
			add: action title
			target: action
			selector: #actOn:
			argument: aPresentation ].
	^ aMenuMorph! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'tg 8/22/2010 23:52'!
moreToolbarActions: noIconActions on: aBrowser
	| menuMorph |
	menuMorph := MenuMorph new.
	noIconActions do: [ :each | 
		menuMorph 
				add: each title
				target: each
				selector: #actOn:
				argument: aBrowser ].
	^ menuMorph! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'TudorGirba 1/23/2011 12:49'!
morph: aMorph withTitleOf: aPresentation	
	| tabs |
	tabs := LazyTabGroupMorph new.
	tabs
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		cornerStyle: (self theme tabGroupCornerStyleIn: nil);
		font: self theme labelFont.
	self flag: 'add a regular page instead of a lazy one'.
	self flag: 'handle the PresentationChanged announcement to update the label in the morph. 
	The problem is that at the moment I do not know how to link to the label in the tabSelectorMorph'.
	tabs 
		addLazyPage: [aMorph]
		label: (self titleOrIconOf: aPresentation in: tabs)
		toolbar: (self renderToolbarForPresentation: aPresentation inMorph: aMorph).
	tabs selectedPageIndex: 1.
	^ tabs! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'TudorGirba 1/31/2011 02:19'!
morph: aMorph withTitleOrNilOf: aPresentation
	(aPresentation hasTitle or: [aPresentation hasTitleIcon]) ifFalse: [
		"we render at least the toolbar"
		^ self morph: aMorph withToolbarOf: aPresentation ].
	^ self morph: aMorph withTitleOf: aPresentation! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'TudorGirba 1/31/2011 02:21'!
morph: aMorph withToolbarOf: aPresentation
	| container offset dock |
	aPresentation hasActions ifFalse: [ ^ aMorph ].
	container := GLMMorphic containerMorph.
	offset := 0.
	dock := self renderToolbarForPresentation: aPresentation inMorph: container.
	offset := dock minExtent y.
	container addMorph: dock fullFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 0) offsets: (0 @ 0 corner: 0 @ offset)).	
	container 
		addMorph: aMorph 
		fullFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1) offsets: (0 @ offset corner: 0 @ 0)).
	^ container! !

!GLMMorphicWidgetRenderer methodsFor: 'rendering' stamp: 'tg 8/22/2010 20:17'!
render: aPresentation
	^ self subclassResponsibility ! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'TudorGirba 1/5/2011 23:47'!
renderObject: anObject
	^ self renderer render: anObject ! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'TudorGirba 1/27/2011 23:54'!
renderToolbarForPresentation: aPresentation inMorph: aMorph
	| dock tools buttons noIconActions |
	dock := aMorph theme newToolDockingBarIn: aMorph.
	buttons := (aPresentation allActions select: [:each | each hasIcon]) collect: [:each |
		(aMorph theme
			newButtonIn: aMorph for: each
			getState: nil
			action: #actOn:
			arguments: {aPresentation}
			getEnabled: nil
			label: (AlphaImageMorph new image: each icon)
			help: each title)
			valueOfProperty: #noBorder ifAbsentPut: [true]; "this is a hack to tell the GLMUITheme to not draw the border and the fill"
			valueOfProperty: #noFill ifAbsentPut: [true];
			setProperty: #wantsKeyboardFocusNavigation toValue: false; "to disable the focus"
			yourself ].
	noIconActions := aPresentation allActions select: [:each | each hasTitle and: [each hasIcon not]].
	tools := aMorph theme newToolbarIn: aMorph for: buttons.
	noIconActions isEmpty ifFalse: [
			| activeForm passiveForm menuButton | 
			activeForm := GLMMorphicIcons toolbarMenuForm.
			passiveForm := GLMMorphicIcons toolbarMenuInactiveForm.
			menuButton := MultistateButtonMorph new extent: activeForm extent.
			menuButton
				extent: activeForm extent;
						activeEnabledOverUpFillStyle: (ImageFillStyle form: activeForm);
						passiveEnabledOverUpFillStyle: (ImageFillStyle form: activeForm);
						activeEnabledOverDownFillStyle: (ImageFillStyle form: passiveForm);
				passiveEnabledOverDownFillStyle: (ImageFillStyle form: passiveForm);
				addUpAction: [ | menu |
						menu := self menuIn: MenuMorph new for: aPresentation.
						menu popUpEvent: self currentEvent in: aMorph world ];
				setBalloonText: 'Menu' translated.
			buttons do: [:each | dock addMorphBack: each ].
			dock addMorphBack: menuButton.
			"isEmpty ifFalse: [dock addMorphBack: tools]" ]
		ifTrue: [ dock addAllMorphs: buttons ].
	^ dock! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'TudorGirba 1/28/2011 19:20'!
renderWithTitle: aPresentation
	| morph |
	morph := self renderObject: aPresentation.
	^ self morph: morph withTitleOf: aPresentation! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'TudorGirba 1/31/2011 02:19'!
renderWithTitleOrNil: aPresentation
	| morph |
	morph := self renderObject: aPresentation.
	^ self morph: morph withTitleOrNilOf: aPresentation! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'TudorGirba 1/31/2011 02:20'!
renderWithToolbar: aPresentation
	| presentationMorph |
	presentationMorph := self renderObject: aPresentation.
	^ self morph: presentationMorph withToolbarOf: aPresentation! !

!GLMMorphicWidgetRenderer methodsFor: 'accessing' stamp: 'TudorGirba 1/5/2011 23:42'!
renderer
	^ renderer ifNil: [renderer := GLMMorphicRenderer new]! !

!GLMMorphicWidgetRenderer methodsFor: 'accessing' stamp: 'tg 8/22/2010 20:20'!
renderer: anObject
	renderer := anObject! !

!GLMMorphicWidgetRenderer methodsFor: 'factory' stamp: 'tg 8/23/2010 00:02'!
theme
	^ UITheme current! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'tg 8/22/2010 23:52'!
titleOrIconOf: aPresentation in: container
	^ aPresentation hasTitleIcon 
		ifTrue: [
			self theme 
					newImageIn: container
					form: aPresentation titleIconValue ]
		ifFalse: [ aPresentation titleValue ifNil: [''] ].! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'tg 8/22/2010 23:52'!
titleOrIconOrNilOf: aPresentation in: container
	^ aPresentation hasTitleIcon 
		ifTrue: [
			self theme 
					newImageIn: container
					form: aPresentation titleIconValue ]
		ifFalse: [ 
			aPresentation hasTitle 
				ifTrue: [ aPresentation titleValue ]
				ifFalse: [ nil ] ]! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicWindowRenderer
	instanceVariableNames: 'window'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicWindowRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 11:23'!
actOnPresentationUpdated: ann
		self setLabelOf: window for: ann presentation! !

!GLMMorphicWindowRenderer methodsFor: 'rendering' stamp: 'cyrilledelaunay 3/25/2011 15:38'!
render: aRenderable
	| dock offset bottomOffset statusbarMorph |
	window := GLMSystemWindow new model:aRenderable .
	window model: aRenderable.
	window on: #keyStroke send: #handleKeyStroke: to: window.
	self installActionsOnUI: window fromPresentation: aRenderable.
	self setLabelOf: window for: aRenderable.
	offset := 4.
	bottomOffset := 0.
	(aRenderable allActions select: [:each | each hasIcon]) notEmpty ifTrue: [ 
		dock := self renderToolbarForPresentation: aRenderable inMorph: window.
		dock hResizing: #shrinkWrap.
		window toolbarBox: dock.
"		offset := dock minExtent y."
"		window addMorph: dock fullFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 0) offsets: (0 @ 0 corner: 0 @ offset))" ].
	aRenderable hasStatusbar
		ifTrue: [ 
			statusbarMorph := GLMMorphicPaneWithoutTitleRenderer render: aRenderable statusbarPane from: self renderer.
			bottomOffset := (0 - (LabelMorph contents: 'XXX') minHeight) * 1.2.
			window
				addMorph: statusbarMorph
				fullFrame: (LayoutFrame fractions: (0 @ 1 corner: 1 @ 1) offsets: (2 @ bottomOffset corner: -2 @ 0)) ].
	window
		addMorph: (self renderObject: aRenderable)
		fullFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1) offsets: (0 @ offset corner: 0 @ bottomOffset)).
	(self theme isKindOf: UIThemeWatery)
		ifFalse: [ aRenderable colorValue ifNotNil: [ window paneColor: aRenderable colorValue ] ].
	aRenderable on: GLMPresentationUpdated send: #actOnPresentationUpdated: to: self.
	^ window! !

!GLMMorphicWindowRenderer methodsFor: 'rendering' stamp: 'tg 8/24/2010 22:06'!
setLabelOf: window for: aRenderable
	window	setLabel: (self titleFor: aRenderable).! !

!GLMMorphicWindowRenderer methodsFor: 'rendering' stamp: 'tg 8/24/2010 22:04'!
titleFor: aRenderable
	^ aRenderable titleValue ifNil: [ 'Glamorous Browser' ]! !
